<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.io.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.jspcr.forward.*" %>
<%
   // Change the following constants if necessary

   final String DRIVER = "com.mysql.jdbc.Driver";
   final String DBURL  = "jdbc:mysql://localhost/usda15";

   // Load the driver class and establish a connection

   Class.forName(DRIVER);
   Connection con = DriverManager.getConnection(DBURL);

   // Run a database query to get the list of food groups

   Statement stmt = con.createStatement();
   String sql = 
        " SELECT   FDGRP_CD, FDGRP_DESC"
      + " FROM     FD_GROUP"
   ;
   ResultSet rs = stmt.executeQuery(sql);

   // Store the results as a list of FoodGroup objects

   List fglist = new ArrayList();
   while (rs.next()) {
      String code = rs.getString(1);
      String desc = rs.getString(2);
      FoodGroup fg = new FoodGroup(code, desc);
      fglist.add(fg);
   }

   rs.close();
   stmt.close();
   con.close();

   // Store the list as a request attribute

   request.setAttribute("com.jspcr.forward.FoodGroups", fglist);

   // Now forward the request

%><jsp:forward page="ShowFoodGroups.jsp" />
