<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>

<%@ page session="true" %>
<%@ page import="com.jspcr.jdbc.*" %>
<%@ page import="java.sql.*" %>
<%
   // Get form parameters or use defaults

   String nationality = request.getParameter("nationality");
   if (nationality == null)
      nationality = "";

   String yearRange = request.getParameter("yearRange");
   if (yearRange == null)
      yearRange = "1901-2000";
%>
<html>
<head>
<title>Composer Search</title>
<style type="text/css">
h1 { font-size: 130%; }
</style>
</head>
<body>
<center>
<h1>Composer Search</h1>
<form method="POST">
<b>Nationality:</b>
<input type="text" name="nationality" value="<%= nationality %>">
<b>Century:</b>
<select name="yearRange">
<%
   // Create the century option list

   for (int century = 16; century <= 20; century++) {
      int fromYear = (century - 1) * 100 + 1;
      int toYear = century * 100;
      StringBuffer sb = new StringBuffer();
      sb.append("<OPTION");
      if (yearRange.startsWith("" + fromYear))
         sb.append(" SELECTED");
      sb.append(" VALUE='");
      sb.append(fromYear);
      sb.append("-");
      sb.append(toYear);
      sb.append("'>");
      sb.append(century);
      sb.append("th Century</OPTION>");
      out.println(sb);
   }
%>
</select>
<input type="submit" value="Search">
</form>
<%
   // If values were entered in the form, display results

   if (!nationality.equals("")) {
%>

<%-- Get the bound connection --%>

<jsp:include page="connect.jsp" flush="true"/>

<table border="0" cellpadding="1" cellspacing="1">
<%
      BoundConnection bcon = (BoundConnection)
         session.getAttribute("bcon");
      Connection con = bcon.getConnection();
      String sql = ""
         + " SELECT   lname, fname, born, died"
         + " FROM     composers"
         + " WHERE    nationality = ?"
         + " AND      ((born between ? and ?)"
         + " OR       (died between ? and ?))"
         + " ORDER BY born, lname"
         ;
      PreparedStatement pstmt = con.prepareStatement(sql);

      int fromYear = Integer.parseInt(yearRange.substring(0, 4));
      int toYear = Integer.parseInt(yearRange.substring(5));

      pstmt.setString(1, nationality);
      pstmt.setInt(2, fromYear);
      pstmt.setInt(3, toYear);
      pstmt.setInt(4, fromYear);
      pstmt.setInt(5, toYear);
      ResultSet rs = pstmt.executeQuery();
      while (rs.next()) {
         String lname = rs.getString(1);
         String fname = rs.getString(2);
         int born = rs.getInt(3);
         int died = rs.getInt(4);
%>
<tr>
   <td><%= fname %> <%= lname %></td>
   <td><%= born %>-<%= died %></td>
</tr>
<%
      }
      rs.close();
      pstmt.close();
%>
</table>
<%
   }
%>
</center>
</body>
</html>
