<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%--
      A JSP page that displays status messages during a
      long-running request and does not tie up server
      resources waiting for the request to complete.
--%>
<%

   // See if there is an authentication worker thread running

   WorkerThread worker = (WorkerThread)
      session.getAttribute("worker");

   // If not, create a new one and start the authentication

   if (worker == null) {
      String userID = request.getParameter("userID");
      String password = request.getParameter("password");
      worker = new WorkerThread(userID, password);
      session.setAttribute("worker", worker);
   }

   // Now display either the "please wait" screen
   // or the "user authenticated" screen

   if (!worker.isDone()) {
      String url = request.getRequestURL().toString();
      url = response.encodeURL(url);
%>
<html>
<head>
<title>Please Wait</title>
<meta http-equiv="REFRESH" content="2; URL=<%= url %>">
</head>
<body>
Authenticating, please wait...
</body>
</html>
<%
   }
   else {
%>
<html>
<head><title>Done</title></head>
<body>
Authentication complete.
<%= worker.isAuthenticated() ? " You pass!" : " You fail!" %>
</body>
</html>
<%
      // Done with worker

      session.invalidate();
   }
%>
<%!
/**
* A background thread that performs a potentially
* long-running task (authentication from a database).
*/
public class WorkerThread implements Runnable
{
   private boolean done;
   private boolean authenticated;
   private Thread kicker;

   public WorkerThread(String userID, String password)
   {
      done = false;
      authenticated = false;
      kicker = new Thread(this);
      kicker.start();
   }

   public boolean isDone()
   {
      return done;
   }

   public boolean isAuthenticated()
   {
      return authenticated;
   }

   public void run()
   {
      // Do the work here

      try {

         // Pretend to do something that takes five seconds

         for (int i = 0; i < 5; i++)
            Thread.sleep(1000);

         // Randomly authenticate 80% of all users

         authenticated = (Math.random() > 0.2);

         // We are done

         done = true;
      }
      catch (InterruptedException ignore) {}
      finally {
         kicker = null;
      }
   }
}
%>
