/**
*  Copyright (c) 2002 by Phil Hanna
*  All rights reserved.
*  
*  You may study, use, modify, and distribute this
*  software for any purpose provided that this
*  copyright notice appears in all copies.
*  
*  This software is provided without warranty
*  either expressed or implied.
*/

import java.text.*;
import java.util.*;

/**
* A class that demonstrates simple multithreading
* using the Runnable interface.
*/
public class ThreadExample2 implements Runnable
{
   public static void main(String[] args)
   {
      new ThreadExample2();
   }

   public ThreadExample2()
   {
      /**
      * Start two Runnable threads each using this run method.
      */

      Thread t1 = new Thread(this);
      t1.setName("A");
      t1.start();

      Thread t2 = new Thread(this);
      t2.setName("B");
      t2.start();
   }

   /**
   * Date format used in message. Includes milliseconds.
   */

   public static final SimpleDateFormat FMT
      = new SimpleDateFormat("hh:mm:ss.SSS aa");

   /**
   * Where the counter loop takes place.
   */
   public void run()
   {
      Thread t = Thread.currentThread();
      System.out.println("Starting " + t.getName());
      for (int i = 0; i < 8; i++) {
         try {
            t.sleep((long) (Math.random() * 500 + 100));
         }
         catch (InterruptedException e) {
            break;
         }
         System.out.println
            (FMT.format(new Date())
            + " Thread " + t.getName()
            + ": Count = " + i);
      }
      System.out.println("Leaving " + t.getName());
   }
}
