/**
*  Copyright (c) 2002 by Phil Hanna
*  All rights reserved.
*  
*  You may study, use, modify, and distribute this
*  software for any purpose provided that this
*  copyright notice appears in all copies.
*  
*  This software is provided without warranty
*  either expressed or implied.
*/

import java.text.*;
import java.util.*;

/**
* A class that demonstrates simple multithreading
* using the Runnable interface implemented by
* an anonymous class.
*/
public class ThreadExample3
{
   public static void main(String[] args)
   {
      // Anonymous runnable thread 1

      new Thread(new Runnable() {

         public void run() {
            for (int i = 0; i < 8; i++) {
               ThreadExample3.sleep(600, 100);
               int n = (int) (Math.random() * flavors.length);
               System.out.println("A: " + flavors[n]);
            }
         }

         private String[] flavors
            = { "Chocolate", "Strawberry", "Vanilla", };

      }).start();

      // Anonymous runnable thread 2

      new Thread(new Runnable() {

         public void run() {
            for (int i = 0; i < 16; i++) {
               ThreadExample3.sleep(300, 50);
               int n = (int) (Math.random() * 100);
               System.out.println("B: " + n);
            }
         }

      }).start();
   }

   /**
   * Utility method that sleeps for a random amount
   * of time.
   */
   private static void sleep(int mean, int lowLimit)
   {
      try {
         long delay = (long)(Math.random() * mean + lowLimit);
         Thread.currentThread().sleep(delay);
      }
      catch (InterruptedException ignore) {}
   }

}
