/**
*  Copyright (c) 2002 by Phil Hanna
*  All rights reserved.
*  
*  You may study, use, modify, and distribute this
*  software for any purpose provided that this
*  copyright notice appears in all copies.
*  
*  This software is provided without warranty
*  either expressed or implied.
*/
package com.jspcr.taglibs.diag;

import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;
import java.net.*;

/**
* Handler for the <code>getWebServer</code> tag
*/
public class GetWebServerTag extends TagSupport
{
   public int doStartTag() throws JspException
   {
      try {
         // Get server host and port number from
         // the page context.

         HttpServletRequest request =
            (HttpServletRequest) pageContext.getRequest();

         String host = request.getServerName();
         int port = request.getServerPort();

         // Make an HTTP request to the web server
         // that will cause it to send back the
         // server information we need.

         URL url = new URL("http", host, port, "/");
         HttpURLConnection con = (HttpURLConnection)
            url.openConnection();
         con.setRequestMethod("OPTIONS");
         String webserver = con.getHeaderField("server");

         // Write it to the output stream

         JspWriter out = pageContext.getOut();
         out.print(webserver);
      }
      catch (IOException e) {
         throw new JspException(e.getMessage());
      }
      return SKIP_BODY;
   }
}
