<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%-- Declare the JSTL taglibs being used --%>

<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt_rt" %>

<%-- Declare the attributes use by the custom tag --%>

<%@ attribute name="from" %>
<%@ attribute name="to" %>
<%@ attribute name="by" %>

<%-- Declare variables used in this tag handler --%>

<%@ variable name-given="f" %>
<%@ variable name-given="c" %>

<%-- Loop over the range of temperatures specified --%>

<c:forEach var="degrees" begin="${from}" end="${to}" step="${by}">

   <%-- Set the values of the variables used
        in the JSP fragment --%>

   <c:set var="f" value="${degrees}"/>
   <c:set var="c">
      <fmt:formatNumber pattern="##0.00">
         ${(f - 32) * 5 / 9.0}
      </fmt:formatNumber>
   </c:set>

   <%-- Invoke the JSP fragment --%>

   <jsp:doBody/>

</c:forEach>
