<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.sql.*" %>
<html>
<head>
<title>Callable Statement Example</title>
<style type="text/css">
body, td, th {
   font-family: Verdana;
   font-size: 9pt;
   text-align: center;
}
h1 { font-size: 130%; }
</style>
</head>
<body>
<h1>Select Composers by Year Born</h1>
<form>
<table>
<%
   // Get beginning and ending years

   String param1 = request.getParameter("lo");
   if (param1 == null)
      param1 = "";

   String param2 = request.getParameter("hi");
   if (param2 == null)
      param2 = "";
%>
<tr>
   <td>Year range:
      <input type="TEXT" name="lo" size="4" value="<%= param1 %>">

      and

      <input type="TEXT" name="hi" size="4" value="<%= param2 %>">
      <input type="SUBMIT" value="Search">
   </td>
</tr>
</table>
</form>
<%
   if (!param1.equals("") && (!param2.equals(""))) {

      int lo = Integer.parseInt(param1);
      int hi = Integer.parseInt(param2);

      Connection con = null;
      CallableStatement cstmt = null;
      ResultSet rs = null;
      try {

         // Load the driver

         Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

         // Connect to the composers database

         con = DriverManager.getConnection
            ("jdbc:odbc:composers");

         // Set up callable procedure

         String sql = "{call BornBetween(?, ?)}";
         cstmt = con.prepareCall(sql);
         cstmt.setInt(1, lo);
         cstmt.setInt(2, hi);
         rs = cstmt.executeQuery();
%>
   <table border=1 cellpadding=3 cellspacing=0>
   <tr>
      <th>Name</th>
      <th>Nationality</th>
      <th>Lived</th>
   </tr>
<%
         // Print the result set

         while (rs.next()) {
            String fname = rs.getString(1);
            String lname = rs.getString(2);
            String nationality = rs.getString(3);
            int yearBorn = rs.getInt(4);
            int yearDied = rs.getInt(5);
%>
   <tr>
      <td><%= fname %> <%= lname %></td>
      <td><%= nationality %></td>
      <td><%= yearBorn %>-<%= yearDied %></td>
   </tr>
<%
         }
%>
   </table>
<%
      }
      finally {
         if (rs != null) rs.close();
         if (cstmt != null) cstmt.close();
         if (con != null) con.close();
      }
   }
%>
</body>
</html>
