<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.io.*" %>
<%@ page import="java.net.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.sql.*" %>
<html>
<head><title>Execute Example</title></head>
<body>
<h1>Execute Example</h1>
<%
   // Get the data source using JNDI

   InitialContext initCtx = new InitialContext();
   Context ctx = (Context) initCtx.lookup("java:comp/env");
   DataSource ds = (DataSource) ctx.lookup("jdbc/LyricNote");

   // Define these objects outside the "try" block so that
   // they can be closed in the "finally" block

   Connection con = null;
   Statement stmt = null;
   ResultSet rs = null;

   try {

      // Get a connection from the data source
      // and a statement from the connection

      con = ds.getConnection();
      stmt = con.createStatement();

      // Read SQL statements from a file
      
      URL dataURL = application.getResource("/examples/data.sql");

      BufferedReader in =
         new BufferedReader(
         new InputStreamReader(
         dataURL.openStream()));

      StringBuffer sb = new StringBuffer();

      out.println("<table border='1'"
                     + "  cellpadding='5'"
                     + "  cellspacing='0'>");

      while (true) {

         // Read characters into a string buffer until
         // a semicolon marking the end of the statement

         int c = in.read();
         if (c == -1)
            break;

         if (c != ';') {
            sb.append((char) c);
            continue;
         }

         // Get the line to be executed and reset the
         // string buffer so it can be reused

         String line = sb.toString().trim();
         sb.setLength(0);
         
         // Execute the line as an SQL statement

         out.println("<tr valign='top'>");
         out.println("<td> <b>Statement:</b> </td>");
         out.println("<td> <pre>" + line + "</pre> </td>");
         out.println("</tr>");

         boolean hasResultSet = stmt.execute(line);
         while (true) {

            if (hasResultSet) {
               
               // Get the result set from the statement
               // and print it in a table

               rs = stmt.getResultSet();

               out.println("<tr valign='top'>");
               out.println("<td><b>Result set:</b></td>");
               out.println("<td>");
               out.println("<table border='0'>");

               ResultSetMetaData rmd = rs.getMetaData();
               int nColumns = rmd.getColumnCount();
               while (rs.next()) {
                  out.println("<tr>");
                  for (int i = 0; i < nColumns; i++) {
                     int col = i+1;
                     String value = rs.getString(col);
                     out.println("<td>" + value + "</td>");
                  }
                  out.println("</tr>");
               }

               out.println("</table>");
               out.println("</td>");
               out.println("</tr>");

               rs.close();
               rs = null;
            }
            else {
               int count = stmt.getUpdateCount();
               if (count == -1)
                  break;
               out.println("<tr valign='top'>");
               out.println("<td><b>Update count:</b></td>");
               out.println("<td>" + count + "</td>");
               out.println("</tr>");
            }

            // See if there are any more results

            hasResultSet = stmt.getMoreResults();
         }
      }
      in.close();
   }
   finally {

      out.println("</table>");

      // Close any open JDBC objects

      if (rs != null) rs.close();
      if (stmt != null) stmt.close();
      if (con != null) con.close();
   }
%>
</body>
</html>
