<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.sql.*" %>
<%@ page import="javax.sql.*" %>
<%@ page import="javax.naming.*" %>
<html>
<head>
<title>Irish Composers</title>
<style type="text/css">
body, td, th { font-family: Verdana; font-size: 9pt; }
h1 { font-size: 130%; }
</style>
</head>
<body>
<h1>Irish Composers</h1>
<table border="0" cellpadding="3" cellspacing="1">
<%
   // Get the data source using JNDI

   InitialContext initCtx = new InitialContext();
   Context ctx = (Context) initCtx.lookup("java:comp/env");
   DataSource ds = (DataSource) ctx.lookup("jdbc/LyricNote");

   // Define these objects outside the "try" block so that
   // they can be closed in the "finally" block

   Connection con = null;
   Statement stmt = null;
   ResultSet rs = null;

   try {

      // Connect to the database

      con = ds.getConnection();
      stmt = con.createStatement();

      // Execute a query to select Irish composers

      String sql =
         "SELECT lname, fname, born, died"
         + " FROM composers"
         + " WHERE nationality = 'Irish'";
      rs = stmt.executeQuery(sql);

      // Loop through each row of the result set

      while (rs.next()) {

         // Extract the two string values and two
         // integer values from the current row

         String lastName = rs.getString(1);
         String firstName = rs.getString(2);
         int born = rs.getInt(3);
         int died = rs.getInt(4);

         // Print a table row with the values
         %>
         <tr>
            <td><%= firstName %> <%= lastName %></td>
            <td><%= born %>-<%= died %></td>
         </tr>
         <%
      }
   }

   // Close any open database objects

   finally {
      if (rs != null) rs.close();
      if (stmt != null) stmt.close();
      if (con != null) con.close();
   }
%>
</table>
</body>
</html>

