<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="com.jspcr.jdbc.tools.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.util.*" %>
<html>
<head>
<title>Metadata Explorer</title>
<style type="text/css">
body, td, th {
   font-family: Verdana;
   font-size: 9pt;
}
th {
   text-align: left;
}
h1 {
   font-size: 130%;
   text-align: center;
}
</style>
</head>
<%
   // Get required driver name parameter

   String driverName = request.getParameter("driverName");
   if (driverName == null)
      driverName = "";
   driverName = driverName.trim();

   // Get required database URL parameter

   String url = request.getParameter("url");
   if (url == null)        
      url = "";
   url = url.trim();

   // Get optional userID parameter

   String userID = request.getParameter("userID");
   if (userID == null)
      userID = "";
   userID = userID.trim();

   // Get optional password parameter

   String password = request.getParameter("password");
   if (password == null)
      password = "";
   password = password.trim();

   Class.forName(driverName);
   Connection con = null;
   try {

      con = DriverManager.getConnection(url, userID, password);
      DatabaseMetaData md = con.getMetaData();
      MetaDataEvaluator mde = new MetaDataEvaluator(md);

      out.println("<body>");
      out.println("<h1>Metadata Explorer for "
         + md.getDatabaseProductName()
         + " "
         + md.getDatabaseProductVersion()
         + "<br/>"
         + "[" + driverName + "]"
         + "</h1>"
         );
      out.println("<table border='1'"
                     +  " cellpadding='3'"
                     +  " cellspacing='0'>");
      out.println("<tr><th>Method</th><th>Value</th></tr>");

      for (Iterator it = mde.getMethodNames(); it.hasNext(); ) {
         String name = (String) it.next();
         Object value = mde.getMethodValue(name);
         out.println("<tr>");
         out.println("<td>" + name + "</td>");
         out.println("<td>" + value + "</td>");
         out.println("</tr>");
      }
   }
   finally {
      if (con != null)
         con.close();
   }
%>
</table>
</body>
</html>
