<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.sql.*,javax.naming.*,javax.sql.*" %>
<html>
<head><title>Query Example</title></head>
<body>
<h1>Query Example</h1>
<%
   // Get the data source using JNDI

   InitialContext initCtx = new InitialContext();
   Context ctx = (Context) initCtx.lookup("java:comp/env");
   DataSource ds = (DataSource) ctx.lookup("jdbc/LyricNote");

   // Define these objects outside the "try" block so that
   // they can be closed in the "finally" block

   Connection con = null;
   Statement stmt = null;
   ResultSet rs = null;

   try {

      // Get a connection from the data source
      // and a statement from the connection

      con = ds.getConnection();
      stmt = con.createStatement();

      // Run the SQL query that selects the products
      // of interest

      rs = stmt.executeQuery(
            "SELECT  itemcode, description"
         + " FROM    products"
         + " WHERE   description like 'Telemann% Concerto%'");

      // Loop through the result set printing each line

      out.println("<pre>");
      out.println("ITEMCODE    DESCRIPTION");
      out.println("--------    -----------");

      while (rs.next()) {
         String itemCode = rs.getString(1);
         String description = rs.getString(2);
         out.println(itemCode + "      " + description);
      }

      out.println("</pre>");
   }
   finally {

      // Close the open JDBC objects

      if (rs != null) rs.close();
      if (stmt != null) stmt.close();
      if (con != null) con.close();
   }
%>
</body>
</html>
