<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.text.*" %>
<%@ page import="java.util.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.sql.*" %>
<%!
   private static final NumberFormat PRICE_FMT
      = NumberFormat.getCurrencyInstance();
%>
<html>
<head>
<title>Scrollable Example</title>
<style type="text/css">
body, td, th {
   font-family: Verdana;
   font-size: 9pt;
}
h1 {
   font-size: 130%;
}
</style>
</head>
<body>
<img src="images/lyric_note.png" border="0">
<div><hr/></div>
<%
   InitialContext initCtx = new InitialContext();
   Context ctx = (Context) initCtx.lookup("java:comp/env");
   DataSource ds = (DataSource) ctx.lookup("jdbc/LyricNote");

   // Declare JDBC objects outside the "try" block

   Connection con = null;
   Statement stmt = null;
   ResultSet rs   = null;

   try {
      con = ds.getConnection();

      stmt = con.createStatement(
         ResultSet.TYPE_SCROLL_INSENSITIVE,
         ResultSet.CONCUR_READ_ONLY);

      rs = stmt.executeQuery(
              " SELECT   itemcode, price, description"
            + " FROM     products"
            + " WHERE    prodtype = 'IN'"
            + " ORDER BY description"
         );

      // Calculate number of rows

      rs.last();
      int nRows = rs.getRow();

      // Back up ten rows

      rs.relative(-10);

      // Now print last page of result set
%>
<h1>
   Musical Instruments -
      Items <%= rs.getRow() + 1 %>
      through <%= nRows %>
</h1>
<table border="1" cellpadding="5" cellspacing="0">
<tr><th>Item</th><th>Price</th><th>Description</th></tr>
<%
      while (rs.next()) {
         String itemcode = rs.getString(1);
         double price = rs.getDouble(2);
         String description = rs.getString(3);
%>
<tr>
   <td><%= itemcode %></td>
   <td align="RIGHT"><%= PRICE_FMT.format(price) %></td>
   <td><%= description %></td>
</tr>
<%
      }
   }
   finally {
      if (rs != null) { rs.close(); rs = null; }
      if (stmt != null) { stmt.close(); stmt = null; }
      if (con != null) { con.close(); con = null; }
   }
%>
</table>
</body>
</html>
