<%--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
--%>
<%@ page session="false" %>
<%@ page import="java.sql.*,javax.naming.*,javax.sql.*" %>
<html>
<head><title>Update Example</title></head>
<body>
<h1>Update Example</h1>
<pre>
<%
   // Get the data source using JNDI

   InitialContext initCtx = new InitialContext();
   Context ctx = (Context) initCtx.lookup("java:comp/env");
   DataSource ds = (DataSource) ctx.lookup("jdbc/LyricNote");

   // Define these objects outside the "try" block so that
   // they can be closed in the "finally" block

   Connection con = null;
   Statement stmt = null;
   ResultSet rs = null;

   try {

      // Get a connection from the data source
      // and a statement from the connection

      con = ds.getConnection();
      stmt = con.createStatement();

      // Get the description from the erroneous listing

      rs = stmt.executeQuery(
            "SELECT  description"
         + " FROM    products"
         + " WHERE   itemcode = '022370'");
      rs.next();
      String description = rs.getString(1);

      // Display the original value and close the result set

      out.println("Original description:      " + description);
      rs.close();

      // Change F# to F (note: the String.replaceFirst()
      // method requires JDK 1.4 or later)

      description = description.replaceFirst("in F#", "in F");

      // Run the SQL update statement to correct
      // the description

      int nRows = stmt.executeUpdate(
           " UPDATE   products"
         + " SET      description = '" + description + "'"
         + " WHERE    itemcode = '022370'"
         );

      // Print the update count

      out.println("Number of rows updated:    " + nRows);

      // Show the new description

      rs = stmt.executeQuery(
            "SELECT  description"
         + " FROM    products"
         + " WHERE   itemcode = '022370'");
      rs.next();
      description = rs.getString(1);

      // Display the new value

      out.println("Updated description:       " + description);
   }
   finally {

      // Close any open JDBC objects

      if (rs != null) rs.close();
      if (stmt != null) stmt.close();
      if (con != null) con.close();
   }
%>
</pre>
</body>
</html>
