/**
*  Copyright (c) 2002 by Phil Hanna
*  All rights reserved.
*  
*  You may study, use, modify, and distribute this
*  software for any purpose provided that this
*  copyright notice appears in all copies.
*  
*  This software is provided without warranty
*  either expressed or implied.
*/
package com.jspcr.xmlsamples;

import java.io.*;
import java.util.*;

/**
* Container for a list of <code>Product</code> objects.
* Parses an XML input stream and fills the list by creating
* <code>Product</code> objects from the XML.
*/
public interface ProductList
{
   /**
   * Returns an iterator over the product list.
   * @exception IOException if an I/O error occurs
   * while constructing the list
   */
   public Iterator iterator() throws IOException;
}
