<?xml version="1.0"?>
<!--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
-->
<xsl:stylesheet
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      version="1.0">

   <xsl:output method="html" encoding="ISO-8859-1"/>

   <xsl:template match="/">
      <html>
         <head>
            <title>
               (XSLT) Clemens-Altman Musical Instruments
            </title>
            <style type="text/css">
<![CDATA[
body, td, th {
   font-family: Verdana;
   font-size: 9pt;
}
h1 { font-size: 130%; }
h2 { font-size: 110%; }
body { text-align: center; }
]]>
            </style>
         </head>
         <body>
            <h1>Clemens-Altman Musical Instruments</h1>
            <h2>(Powered by XSLT)</h2>
            <xsl:apply-templates select="products"/>
         </body>
      </html>
   </xsl:template>

   <xsl:template match="products">
      <table border="1" cellpadding="3" cellspacing="0">
         <tr>
            <th>Product Code</th>
            <th>Description</th>
            <th>Price</th>
         </tr>
         <xsl:apply-templates
            select="product[manufacturer='Clemens-Altman']"/>
      </table>
   </xsl:template>

   <xsl:template match="product">
   <tr>
      <td><xsl:value-of select="@code"/></td>
      <td><xsl:value-of select="description"/></td>
      <td align="right"><xsl:value-of select="price"/></td>
   </tr>
   </xsl:template>

</xsl:stylesheet>
