<?xml version="1.0"?>
<!--
  Copyright (c) 2002 by Phil Hanna
  All rights reserved.
  
  You may study, use, modify, and distribute this
  software for any purpose provided that this
  copyright notice appears in all copies.
  
  This software is provided without warranty
  either expressed or implied.
-->
<jsp:root
   xmlns:jsp="http://java.sun.com/JSP/Page"
   version="2.0"
   >

   <!--  XML Syntax of ClemensAltman.jsp -->

   <jsp:directive.page session="false"/>
   <jsp:directive.page import="java.io.*"/> 
   <jsp:directive.page import="com.jspcr.xmlsamples.*" />
   <jsp:directive.page import="java.net.*"/> 
   <jsp:directive.page import="java.text.*"/> 
   <jsp:directive.page import="java.util.*"/> 
   <jsp:directive.page contentType="text/html"/> 
   <jsp:scriptlet>
      ProductList productList =
         (ProductList) request.getAttribute("productList");
      if (productList == null)
         throw new ServletException
            ("No productList request attribute found");

      String parserType =
         (String) request.getAttribute("parserType");
      if (parserType == null)
         throw new ServletException
            ("No parserType request attribute found");
   </jsp:scriptlet>
   <jsp:element name="html">
      <jsp:element name="head">
         <jsp:element name="title">
            <jsp:text>(</jsp:text>
            <jsp:expression>parserType</jsp:expression>
            <jsp:text>) Clemens-Altman Musical Instruments</jsp:text>
         </jsp:element>
         <jsp:element name="style">
            <jsp:text>
               body, td, th {
                  font-family: Verdana;
                  font-size: 9pt;
               }
               body {
                  text-align: center;
               }
               h1 { font-size: 130%; }
               h2 { font-size: 110%; }
            </jsp:text>
         </jsp:element>
      </jsp:element>
      <jsp:element name="body">
         <jsp:element name="h1">
            <jsp:text>Clemens-Altman Musical Instruments</jsp:text>
         </jsp:element>
         <jsp:element name="h2">
            <jsp:text>(Powered by </jsp:text>
            <jsp:expression>parserType</jsp:expression>
            <jsp:text>)</jsp:text>
         </jsp:element>
         <jsp:element name="table">
            <jsp:attribute name="border">1</jsp:attribute>
            <jsp:attribute name="cellpadding">3</jsp:attribute>
            <jsp:attribute name="cellspacing">0</jsp:attribute>
            <jsp:element name="tr">
               <jsp:element name="th">
                  <jsp:text>Product Code</jsp:text>
               </jsp:element>
               <jsp:element name="th">
                  <jsp:text>Description</jsp:text>
               </jsp:element>
               <jsp:element name="th">
                  <jsp:text>Price</jsp:text>
               </jsp:element>
            </jsp:element>
            <jsp:scriptlet>
               NumberFormat fmt = NumberFormat.getCurrencyInstance();
               for (Iterator it = productList.iterator(); it.hasNext(); ) {
                  Product product = (Product) it.next();
                  if (product.getManufacturer().equals("Clemens-Altman")) {
            </jsp:scriptlet>
            <jsp:element name="tr">
               <jsp:element name="td">
                  <jsp:expression>product.getCode()</jsp:expression>
               </jsp:element>
               <jsp:element name="td">
                  <jsp:expression>product.getDescription()</jsp:expression>
               </jsp:element>
               <jsp:element name="td">
                  <jsp:attribute name="align">right</jsp:attribute>
                  <jsp:expression>fmt.format(product.getPrice())</jsp:expression>
               </jsp:element>
            </jsp:element>
            <jsp:scriptlet>}}</jsp:scriptlet>
         </jsp:element>
      </jsp:element>
   </jsp:element>
</jsp:root>
